
///////////////////////////////////////////////////////////////
// mainCodeBase.js
//
// Copyright (c) 2002 BiZZdesign bv, Enschede. 
//
// Created by PZ, 2002-09-02
///////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////
// Initialization
/////////////////////////////////////////////////////

// Documents
var _docBrowser = '';               // hide all documents
var _docIndex   = '';
var _docDiagram = '';
var _docSummary = '';
var _docDetails = '';

// Display mode
var _floatBrowser = false;          // show all documents in frames
var _floatIndex   = false;
var _floatSummary = false;
var _floatDetails = false;

var _popupsLocked = false;

var _browserOnRightSide = false;    // browser/index on left side

var _browserFrameVisible = true;    // all frames on screen
var _indexFrameVisible   = true;
var _summaryFrameVisible = true;
var _detailsFrameVisible = true;

var _smooth   = true;               // 'smooth sliding' frames
var _steps    = 10;
var _interval = 30;	                // 300 ms total

var _keepDetails = true;            // try to sync details when refreshing summary

var _diagramExploded = false;

// Pointers to popup windows
var _browserWindow = null;          // no popup windows created yet
var _indexWindow   = null;
var _summaryWindow = null;
var _detailsWindow = null;
var _linkWindow    = null;
var _infoWindow    = null;

// Frames layout
var _browserWidth = 20;
var _browserHeight = 50;
var _diagramHeight = 60;
var _summaryWidth = 50;

var _framesizesLocked = false;

// Popups layout
var _browserPopupTop    = 112;           // by default, cascade popups and use 1024x768 frame sizes
var _browserPopupLeft   = 0;
var _browserPopupHeight = 274;
var _browserPopupWidth  = 200;
var _indexPopupTop      = _browserPopupTop + 30;
var _indexPopupLeft     = _browserPopupLeft + 30;
var _indexPopupHeight   = _browserPopupHeight;
var _indexPopupWidth    = _browserPopupWidth;
var _summaryPopupTop    = _indexPopupTop + 100;
var _summaryPopupLeft   = _indexPopupLeft + 100;
var _summaryPopupHeight = 230;
var _summaryPopupWidth  = 400;
var _detailsPopupTop    = _summaryPopupTop + 30;
var _detailsPopupLeft   = _summaryPopupLeft + 30;
var _detailsPopupHeight = _summaryPopupHeight;
var _detailsPopupWidth  = _summaryPopupWidth;

// Fixed pages
var _blankPage    = '';
var _deepLinkPage = '';

// Helper variables
var _deferredStorePending = 0;
var _busyShowingHiding = false;

/////////////////////////////////////////////////////
// Frames handling
/////////////////////////////////////////////////////

function initFrames()
{
    var doc = window.mainframe.document.open("text/html", "replace");
    if (doc == null)
        return;
    var newContent = getPageContent();
    doc.writeln(newContent);
    doc.close();
    if (_framesizesLocked)
    {
        window.mainframe.browser_index.all.browser.noResize = true;
        window.mainframe.browser_index.all.index.noResize = true;
        window.mainframe.summary_details.all.summary.noResize = true;
        window.mainframe.summary_details.all.details.noResize = true;
    }
    hideBrowserFrame();
    hideIndexFrame();
    hideSummaryFrame();
    hideDetailsFrame();
}

function showBrowserFrame(smooth)
{
    if (_diagramExploded)
        implodeDiagramFrame();
    if (!_browserFrameVisible)
    {
        if (!_framesizesLocked)
            window.mainframe.browser_index.all.browser.noResize = false;
        window.mainframe.browser_index.all.browser.frameBorder = 'yes';
        if (_indexFrameVisible)     // index visible: left/right frame exists
        {
            if (smooth)
            {
		        var time = 0;
                var toId = 0;
		        for (var perc = 0; perc < _browserHeight; perc += (_browserHeight/_steps))
		        {
			        time += _interval;
			        toId = setTimeout('_busyShowingHiding = true; clearTimeout(' + toId + '); setBrowserHeight(' + perc + ')', time);
		        }
		        time += _interval;
		        setTimeout('clearTimeout(' + toId + '); setBrowserHeight(' + _browserHeight + '); _busyShowingHiding = false', time);
            }
            else
            {
                setBrowserHeight(_browserHeight);
            }
        }
        else                        // no index either: left/right frame invisible
        {
            // First show browser (not visible yet)
            setBrowserHeight(100);
            // Then show left/right frame
            showBrowserIndexFrame(smooth);
        }
        _browserFrameVisible = true;
    }
}
function hideBrowserFrame(smooth)
{
    if (_diagramExploded)
        implodeDiagramFrame();
    if (_browserFrameVisible)
    {
        if (_indexFrameVisible)     // index visible: left/right frame must stay
        {
            persistBrowserHeight();
            if (smooth)
            {
            var time = 0;
			var toId = 0;
		        for (var perc = _browserHeight; perc > 0; perc -= (_browserHeight/_steps))
		        {
			        time += _interval;
			        toId = setTimeout('_busyShowingHiding = true; clearTimeout(' + toId + '); setBrowserHeight(' + perc + ')', time);
		        }
		        time += _interval;
		        setTimeout('clearTimeout(' + toId + '); setBrowserHeight(0); _busyShowingHiding = false', time);
            }
            else
            {
                setBrowserHeight(0);
            }
        }
        else                        // no index either: left/right frame must be hidden also
        {
            // First hide left/right frame
            hideBrowserIndexFrame(smooth);
            // Then hide browser (not visible anymore)
            setBrowserHeight(0);
        }
        _browserFrameVisible = false;
        if (!_framesizesLocked)
            window.mainframe.browser_index.all.browser.noResize = true;
        window.mainframe.browser_index.all.browser.frameBorder = 'no';
    }
}

function showIndexFrame(smooth)
{
    if (_diagramExploded)
        implodeDiagramFrame();
    if (!_indexFrameVisible)
    {
        if (!_framesizesLocked)
            window.mainframe.browser_index.all.index.noResize = false;
        window.mainframe.browser_index.all.index.frameBorder = 'yes';
        if (_browserFrameVisible)
        {
            if (smooth)
            {
		        var time = 0;
                var toId = 0;
		        for (var perc = 0; perc < (100 - _browserHeight); perc += ((100 - _browserHeight)/_steps))
		        {
			        time += _interval;
			        toId = setTimeout('_busyShowingHiding = true; clearTimeout(' + toId + '); setBrowserHeight(' + (100 - perc) + ')', time);
		        }
		        time += _interval;
		        setTimeout('clearTimeout(' + toId + '); setBrowserHeight(' + _browserHeight + '); _busyShowingHiding = false', time);
            }
            else
            {
                setBrowserHeight(_browserHeight);
            }
        }
        else
        {
            setBrowserHeight(0);
            showBrowserIndexFrame(smooth);
        }
        _indexFrameVisible = true;
    }
}
function hideIndexFrame(smooth)
{
    if (_diagramExploded)
        implodeDiagramFrame();
    if (_indexFrameVisible)
    {
        if (_browserFrameVisible)
        {
            persistBrowserHeight();
            if (smooth)
            {
		        var time = 0;
                var toId = 0;
		        for (var perc = (100 - _browserHeight); perc > 0; perc -= ((100 - _browserHeight)/_steps))
		        {
			        time += _interval;
			        toId = setTimeout('_busyShowingHiding = true; clearTimeout(' + toId + '); setBrowserHeight(' + (100 - perc) + ')', time);
		        }
		        time += _interval;
		        setTimeout('clearTimeout(' + toId + '); setBrowserHeight(100); _busyShowingHiding = false', time);
            }
            else
            {
                setBrowserHeight(100);
            }
        }
        else
        {
            hideBrowserIndexFrame(smooth);
            setBrowserHeight(100);
        }
        _indexFrameVisible = false;
        if (!_framesizesLocked)
            window.mainframe.browser_index.all.index.noResize = true;
        window.mainframe.browser_index.all.index.frameBorder = 'no';
    }
}

function showSummaryFrame(smooth)
{
    if (_diagramExploded)
        implodeDiagramFrame();
    if (!_summaryFrameVisible)
    {
        if (!_framesizesLocked)
            window.mainframe.summary_details.all.summary.noResize = false;
        window.mainframe.summary_details.all.summary.frameBorder = 'yes';
        if (_detailsFrameVisible)
        {
            if (smooth)
            {
		        var time = 0;
                var toId = 0;
		        for (var perc = 0; perc < _summaryWidth; perc += (_summaryWidth/_steps))
		        {
			        time += _interval;
			        toId = setTimeout('_busyShowingHiding = true; clearTimeout(' + toId + '); setSummaryWidth(' + perc + ')', time);
		        }
		        time += _interval;
		        setTimeout('clearTimeout(' + toId + '); setSummaryWidth(' + _summaryWidth + '); _busyShowingHiding = false', time);
            }
            else
            {
                setSummaryWidth(_summaryWidth);
            }
        }
        else
        {
            setSummaryWidth(100);
            showSummaryDetailsFrame(smooth);
        }
        _summaryFrameVisible = true;
    }
}
function hideSummaryFrame(smooth)
{
    if (_diagramExploded)
        implodeDiagramFrame();
    if (_summaryFrameVisible)
    {
        if (_detailsFrameVisible)
        {
            persistSummaryWidth();
            if (smooth)
            {
		        var time = 0;
                var toId = 0;
		        for (var perc = _summaryWidth; perc > 0; perc -= (_summaryWidth/_steps))
		        {
			        time += _interval;
			        toId = setTimeout('_busyShowingHiding = true; clearTimeout(' + toId + '); setSummaryWidth(' + perc + ')', time);
		        }
		        time += _interval;
		        setTimeout('clearTimeout(' + toId + '); setSummaryWidth(0); _busyShowingHiding = false', time);
            }
            else
            {
                setSummaryWidth(0);
            }
        }
        else
        {
            hideSummaryDetailsFrame(smooth);
            setSummaryWidth(0);
        }
        _summaryFrameVisible = false;
        if (!_framesizesLocked)
            window.mainframe.summary_details.all.summary.noResize = true;
        window.mainframe.summary_details.all.summary.frameBorder = 'no';
    }
}

function showDetailsFrame(smooth)
{
    if (_diagramExploded)
        implodeDiagramFrame();
    if (!_detailsFrameVisible)
    {
        if (!_framesizesLocked)
            window.mainframe.summary_details.all.details.noResize = false;
        window.mainframe.summary_details.all.details.frameBorder = 'yes';
        if (_summaryFrameVisible)
        {
            if (smooth)
            {
		        var time = 0;
                var toId = 0;
		        for (var perc = 0; perc < (100 - _summaryWidth); perc += ((100 - _summaryWidth)/_steps))
		        {
			        time += _interval;
			        toId = setTimeout('_busyShowingHiding = true; clearTimeout(' + toId + '); setSummaryWidth(' + (100 - perc) + ')', time);
		        }
		        time += _interval;
		        setTimeout('clearTimeout(' + toId + '); setSummaryWidth(' + _summaryWidth + '); _busyShowingHiding = false', time);
            }
            else
            {
                setSummaryWidth(_summaryWidth);
            }
        }
        else
        {
            setSummaryWidth(0);
            showSummaryDetailsFrame(smooth);
        }
        _detailsFrameVisible = true;
    }
}
function hideDetailsFrame(smooth)
{
    if (_diagramExploded)
        implodeDiagramFrame();
    if (_detailsFrameVisible)
    {
        if (_summaryFrameVisible)
        {
            persistSummaryWidth();
            if (smooth)
            {
		        var time = 0;
                var toId = 0;
		        for (var perc = (100 - _summaryWidth); perc > 0; perc -= ((100 - _summaryWidth)/_steps))
		        {
			        time += _interval;
			        toId = setTimeout('_busyShowingHiding = true; clearTimeout(' + toId + '); setSummaryWidth(' + (100 - perc) + ')', time);
		        }
		        time += _interval;
		        setTimeout('clearTimeout(' + toId + '); setSummaryWidth(100); _busyShowingHiding = false', time);
            }
            else
            {
                setSummaryWidth(100);
            }
        }
        else
        {
            hideSummaryDetailsFrame();
            setSummaryWidth(100);
        }
        _detailsFrameVisible = false;
        if (!_framesizesLocked)
            window.mainframe.summary_details.all.details.noResize = true;
        window.mainframe.summary_details.all.details.frameBorder = 'no';
    }
}


function showBrowserIndexFrame(smooth)
{
    if (smooth)
    {
		var time = 0;
		var toId = 0;
		for (var perc = 0; perc < _browserWidth; perc += (_browserWidth/_steps))
		{
			time += _interval;
            toId = setTimeout('_busyShowingHiding = true; clearTimeout(' + toId + '); setBrowserWidth(' + (_browserOnRightSide ? 100 - perc : perc) + ')', time);
		}
		time += _interval;
        setTimeout('clearTimeout(' + toId + '); setBrowserWidth(' + (_browserOnRightSide ? 100 - _browserWidth : _browserWidth) + '); _busyShowingHiding = false', time);
    }
    else
    {
        setBrowserWidth((_browserOnRightSide ? 100 - _browserWidth : _browserWidth));
    }
}
function hideBrowserIndexFrame(smooth)
{
    persistBrowserWidth();
    if (_browserFrameVisible && _indexFrameVisible)
        persistBrowserHeight();
    if (smooth)
    {
		var time = 0;
		var toId = 0;
		for (var perc = _browserWidth; perc > 0; perc -= (_browserWidth/_steps))
		{
			time += _interval;
            toId = setTimeout('_busyShowingHiding = true; clearTimeout(' + toId + '); setBrowserWidth(' + (_browserOnRightSide ? 100 - perc : perc) + ')', time);
		}
		time += _interval;
		setTimeout('clearTimeout(' + toId + '); setBrowserWidth(' + (_browserOnRightSide ? 100 : 0) + '); _busyShowingHiding = false', time);
    }
    else
    {
        setBrowserWidth((_browserOnRightSide ? 100 : 0));
    }
}
function showSummaryDetailsFrame(smooth)
{
    if (smooth)
    {
		var time = 0;
		var toId = 0;
		for (var perc = 0; perc < (100 - _diagramHeight); perc += ((100 - _diagramHeight)/_steps))
		{
			time += _interval;
			toId = setTimeout('_busyShowingHiding = true; clearTimeout(' + toId + '); setDiagramHeight(' + (100 - perc) + ')', time);
		}
		time += _interval;
		setTimeout('clearTimeout(' + toId + '); setDiagramHeight(' + _diagramHeight + '); _busyShowingHiding = false', time);
    }
    else
    {
        setDiagramHeight(_diagramHeight);
    }
}
function hideSummaryDetailsFrame(smooth)
{
    persistDiagramHeight();
    if (_summaryFrameVisible && _detailsFrameVisible)
        persistSummaryWidth();
    if (smooth)
    {
		var time = 0;
		var toId = 0;
		for (var perc = (100 - _diagramHeight); perc > 0; perc -= ((100 - _diagramHeight)/_steps))
		{
			time += _interval;
			toId = setTimeout('_busyShowingHiding = true; clearTimeout(' + toId + '); setDiagramHeight(' + (100 - perc) + ')', time);
		}
		time += _interval;
		setTimeout('clearTimeout(' + toId + '); setDiagramHeight(100); _busyShowingHiding = false', time);
    }
    else
    {
        setDiagramHeight(100);
    }
}

function explodeDiagramFrame()
{
    // note: has no effect on visibility state!
    if (_browserFrameVisible || _indexFrameVisible)
        hideBrowserIndexFrame(_smooth);

    if (_summaryFrameVisible || _detailsFrameVisible)
        hideSummaryDetailsFrame(_smooth);

    _diagramExploded = true;
    window.bannerframe.syncExplodeImplodeButton();
}
function implodeDiagramFrame()
{
    if (_browserFrameVisible || _indexFrameVisible)
        showBrowserIndexFrame(_smooth);

    if (_summaryFrameVisible || _detailsFrameVisible)
        showSummaryDetailsFrame(_smooth);

    _diagramExploded = false;
    window.bannerframe.syncExplodeImplodeButton();
}

function setBrowserHeight(height)
{
    // Check, because deferred call might outlive callee
    if (height != null &&
        window.mainframe != null &&
        window.mainframe.browser_index)
    {
        window.mainframe.browser_index.rows = '' + height + '%,*';
    }
}
function setBrowserWidth(width)
{
    // Check, because deferred call might outlive callee
    if (width != null &&
        window.mainframe != null &&
        window.mainframe.left_right)
    {
        window.mainframe.left_right.cols = '' + width + '%,*';
    }
}
function setDiagramHeight(height)
{
    // Check, because deferred call might outlive callee
    if (height != null &&
        window.mainframe != null &&
        window.mainframe.diagram_bottom)
    {
        window.mainframe.diagram_bottom.rows = '' + height + '%,*';
    }
}
function setSummaryWidth(width)
{
    // Check, because deferred call might outlive callee
    if (width != null &&
        window.mainframe != null &&
        window.mainframe.summary_details)
    {
        window.mainframe.summary_details.cols = '' + width + '%,*';
    }
}

//-------------------------------------------------------

/////////////////////////////////////////////////////
// Deep linking
/////////////////////////////////////////////////////

// Popup a window displaying a hyperlink to the current
// report state. Document state only, window state is default
function showDeepLink()
{
    _linkWindow = createPopup(_deepLinkPage, "linkPopup", 200, 100, 200, 700);
    var keepWaiting = true; 
    var toId = setTimeout('keepWaiting == false', 5000); 
    while (keepWaiting && _linkWindow.document.all.deeplink == null); 
    clearTimeout(toId); 
    setTimeout(writeDeepLink, 10); 
}

function writeDeepLink()
{
    var deepLink = window.document.location.href;
    var qmark = deepLink.indexOf('?', 0);
    if (qmark > -1)
        deepLink = deepLink.substring(0, qmark);

    var state = '';
    if (_docBrowser != '')
        state += 'browser=' + _docBrowser;
    if (_docIndex != '')
        state += (state != '' ? '+' : '') + 'index=' + _docIndex;
    if (_docDiagram != '')
        state += (state != '' ? '+' : '') + 'diagram=' + _docDiagram;
    if (_docSummary != '')
        state += (state != '' ? '+' : '') + 'summary=' + _docSummary;
    if (_docDetails != '')
        state += (state != '' ? '+' : '') + 'details=' + _docDetails;

    deepLink += '?' + escape(state);

    if (_linkWindow != null)
    {
        _linkWindow.document.all.deeplink.innerHTML = deepLink;
        _linkWindow.focus();
    }
}

// Initialize the report state to the deep link forwarded
// via the HTML 'search' string (parameter list appended to url)
function linkDeep(search)
{
    if (search.charAt(0) == '?')               // strip a leading '?'
        search = search.substring(1, search.length);

    search = unescape(search);

    var docBrowser = '';
    var docIndex = '';
    var docDiagram = '';
    var docSummary = '';
    var docDetails = '';
   
    var docStates = search.split('+');
    if (docStates)
    {
        for (var idx = 0; idx < docStates.length; idx++)
        {
            var docState = docStates[idx].split('=');
            if (docState[0] == 'browser') docBrowser = docState[1];
            else if (docState[0] == 'index') docIndex = docState[1];
            else if (docState[0] == 'diagram') docDiagram = docState[1];
            else if (docState[0] == 'summary') docSummary = docState[1]
            else if (docState[0] == 'details') docDetails = docState[1]
        }
    }

    if (docBrowser != '')
        loadBrowser(docBrowser);
    if (docIndex != '')
        loadIndex(docIndex);
    if (docDiagram != '' && docSummary != '')
        loadDiagramOverview(docDiagram, docSummary);
    else if (docDiagram != '')
        loadDiagram(docDiagram);
    else
        loadSummary(docSummary);
    if (docDetails != '')
        loadDetails(docDetails);
}

/////////////////////////////////////////////////////
// Loading routines
/////////////////////////////////////////////////////

function loadDiagram(diagramHref)
{
    if (_diagramExploded)
        implodeDiagramFrame();
    // If appropriate, the summary is unloaded by the diagram
    if (_docDiagram != diagramHref)         // skip if already loaded
    {
        _docDiagram = diagramHref;
        window.mainframe.diagram.location.href = diagramHref;
    }
}

function loadBrowser(browserHref)
{
    if (_diagramExploded)
        implodeDiagramFrame();
    if (browserHref == _blankPage)          // blankpage: unload
    {
        unloadBrowser();
        return;
    }
    if (_docBrowser != browserHref)
    {
        _docBrowser = browserHref;
        if (_floatBrowser)
            createBrowserPopup(_docBrowser);
        else
            window.mainframe.browser.location.href = browserHref;
    }
    else if (_floatBrowser)
    {
        if(_browserWindow != null && !_browserWindow.closed)
            _browserWindow.focus();
        else
            createBrowserPopup(_docBrowser);
    }
    if (!_floatBrowser && !_browserFrameVisible)
        showBrowserFrame(_smooth);
}

function unloadBrowser()
{
    if (_diagramExploded)
        implodeDiagramFrame();
    if (_docBrowser != '')                  // skip if already gone
    {
        _docBrowser = '';
        if (_floatBrowser)
            destroyBrowserPopup();
        else
            hideBrowserFrame(_smooth);
    }
}

function toggleFloatingBrowser()
{
    if (_popupsLocked)
        return;
    if (_diagramExploded)
        implodeDiagramFrame();
    if (_docBrowser != '')                  // nothing to toggle without a document
    {
        _floatBrowser = !_floatBrowser;     // toggle
        if (_floatBrowser)
        {
            createBrowserPopup(_docBrowser);
            hideBrowserFrame(_smooth);
        }
        else
        {
            destroyBrowserPopup();
            window.mainframe.browser.location.href = _docBrowser;
            showBrowserFrame(_smooth);
        }
    }
}

function loadIndex(indexHref)
{
    if (_diagramExploded)
        implodeDiagramFrame();
    if (indexHref == _blankPage)
    {
        unloadIndex();
        return;
    }
    if (_docIndex != indexHref)
    {
        _docIndex = indexHref;
        if (_floatIndex)
            createIndexPopup(_docIndex);
        else 
            window.mainframe.index.location.href = indexHref;
    }
    else if (_floatIndex)
    {
        if(_indexWindow != null && !_indexWindow.closed)
            _indexWindow.focus();
        else
            createIndexPopup(_docIndex);
    }
    if (!_floatIndex && !_indexFrameVisible)
        showIndexFrame(_smooth);
}

function unloadIndex()
{
    if (_diagramExploded)
        implodeDiagramFrame();
    if (_docIndex != '')
    {
        _docIndex = '';
        if (_floatIndex)
            destroyIndexPopup();
        else
            hideIndexFrame(_smooth);
    }
}

function toggleFloatingIndex()
{
    if (_popupsLocked)
        return;
    if (_diagramExploded)
        implodeDiagramFrame();
    if (_docIndex != '')
    {
        _floatIndex = !_floatIndex;
        if (_floatIndex)
        {
            createIndexPopup(_docIndex);
            hideIndexFrame(_smooth);
        }
        else
        {
            destroyIndexPopup();
            window.mainframe.index.location.href = _docIndex;
            showIndexFrame(_smooth);
        }
    }
}

function loadSummary(summaryHref)
{
    if (_diagramExploded)
        implodeDiagramFrame();
    if (summaryHref == _blankPage)
    {
        unloadSummary();
        return;
    }
    unloadDetails();                    // new summary, clean details
    if (_docSummary != summaryHref)
    {
        _docSummary = summaryHref;
        if (_floatSummary)
            createSummaryPopup(_docSummary);
        else 
            window.mainframe.summary.location.href = summaryHref;
    }
    else if (_floatSummary)
    {
        if(_summaryWindow != null && !_summaryWindow.closed)
            _summaryWindow.focus();
        else
            createSummaryPopup(_docSummary);
    }
    if (!_floatSummary && !_summaryFrameVisible)
        showSummaryFrame(_smooth);
}

function loadOverview(overviewHref)
{
    loadSummary(overviewHref);
}

function unloadSummary()
{
    if (_diagramExploded)
        implodeDiagramFrame();
    unloadDetails();                    // without summary no details
    if (_docSummary != '')
    {
        _docSummary = '';
        if (_floatSummary)
            destroySummaryPopup();
        else
            hideSummaryFrame(_smooth);
    }
}

function unloadOverview()
{
    unloadSummary();
}

function toggleFloatingSummary()
{
    if (_popupsLocked)
        return;
    if (_diagramExploded)
        implodeDiagramFrame();
    if (_docSummary != '')
    {
        _floatSummary = !_floatSummary;
        if (_floatSummary)
        {
            createSummaryPopup(_docSummary);
            hideSummaryFrame(_smooth);
        }
        else
        {
            destroySummaryPopup();
            window.mainframe.summary.location.href = _docSummary;
            showSummaryFrame(_smooth);
        }
    }
}

function toggleFloatingOverview()
{
    toggleFloatingSummary();
}

function loadDetails(detailsHref)
{
    if (_diagramExploded)
        implodeDiagramFrame();
    if (detailsHref == _blankPage)
    {
        unloadDetails();
        return;
    }
    if (_docDetails != detailsHref)
    {
        _docDetails = detailsHref;
        if (_floatDetails)
            createDetailsPopup(_docDetails);
        else 
            window.mainframe.details.location.href = detailsHref;
    }
    else if (_floatDetails)
    {
        if (_detailsWindow != null && !_detailsWindow.closed)
            _detailsWindow.focus();
        else
            createDetailsPopup(_docDetails);
    }
    if (!_floatDetails && !_detailsFrameVisible)
        showDetailsFrame(_smooth);
}

function unloadDetails()
{
    if (_diagramExploded)
        implodeDiagramFrame();
    if (_docDetails != '')
    {
        _docDetails = '';
        if (_floatDetails)
            destroyDetailsPopup();
        else
            hideDetailsFrame(_smooth);
    }
}

function toggleFloatingDetails()
{
    if (_popupsLocked)
        return;
    if (_diagramExploded)
        implodeDiagramFrame();
    if (_docDetails != '')
    {
        _floatDetails = !_floatDetails;
        if (_floatDetails)
        {
            createDetailsPopup(_docDetails);
            hideDetailsFrame(_smooth);
        }
        else
        {
            destroyDetailsPopup();
            window.mainframe.details.location.href = _docDetails;
            showDetailsFrame(_smooth);
        }
    }
}

function loadDiagramOverview(diagramHref, summaryHref)
{
    if (_diagramExploded)
        implodeDiagramFrame();
    if (_docDiagram != diagramHref ||
        _docSummary != summaryHref)         // skip if already loaded
    {
        if (_docDiagram != diagramHref)
        {
            _docDiagram = diagramHref;
            window.mainframe.diagram.location.href = diagramHref;
        }
        if (summaryHref == _blankPage)
        {
            unloadSummary();
            return;
        }
        unloadDetails();                    // new summary, clean details
        if (_docSummary != summaryHref)
        {
            _docSummary = summaryHref;
            if (_floatSummary)
                createSummaryPopup(_docSummary);
            else 
                window.mainframe.summary.location.href = summaryHref;
        }
        else if (_floatSummary)
        {
            if(_summaryWindow != null && !_summaryWindow.closed)
                _summaryWindow.focus();
            else
                createSummaryPopup(_docSummary);
        }
        if (!_floatSummary && !_summaryFrameVisible)
            showSummaryFrame(_smooth);
    }
}

function loadSummaryDetails(summaryHref, existingDetails)
{
    if (_diagramExploded)
        implodeDiagramFrame();
    if (summaryHref == _blankPage)
    {
        unloadSummary();
        return;
    }
    if (_docSummary != summaryHref)
    {
        _docSummary = summaryHref;
        if (_floatSummary)
            createSummaryPopup(_docSummary);
        else 
            window.mainframe.summary.location.href = summaryHref;
    }
    else if (_floatSummary)
    {
        if(_summaryWindow != null && !_summaryWindow.closed)
            _summaryWindow.focus();
        else
            createSummaryPopup(_docSummary);
    }

    if (_keepDetails && existingDetails != null && existingDetails != '' &&
        _docSummary != '' && _docSummary.indexOf('summary') == 0 && _docDetails != '')
    {
        var existing = existingDetails.split(';');
        var idx;
        for (idx = 0; idx < existing.length; idx++)
        {
            if (_docDetails.indexOf(existing[idx]) == 0)
            {
                break;
            }
        }
        if (idx < existing.length)
        {
            var dotPosSum = _docSummary.indexOf('.');
            var dotPosDet = _docDetails.indexOf('.');
            var newDetails = _docDetails.substring(0, existing[idx].length) + _docSummary.substring(7, dotPosSum) + '.' + _docDetails.substring(dotPosDet + 1, _docDetails.length);
            loadDetails(newDetails);
        }
        else
        {
            unloadDetails();
        }
    }
    else
    {
         unloadDetails();
    }
    if (!_floatSummary && !_summaryFrameVisible)
        showSummaryFrame(_smooth);
}

/////////////////////////////////////////////////////
// Popup handling routines
/////////////////////////////////////////////////////

function createBrowserPopup(doc)
{
    if (_browserWindow == null || _browserWindow.closed)
        _browserWindow = createPopup(doc, 'browserPopup', _browserPopupTop, _browserPopupLeft, _browserPopupHeight, _browserPopupWidth);
    else
        _browserWindow.document.location.href = doc;

    if (_browserWindow != null && !_browserWindow.closed)
        _browserWindow.focus();
}

function createIndexPopup(doc)
{
    if (_indexWindow == null || _indexWindow.closed)
        _indexWindow = createPopup(doc, 'indexPopup', _indexPopupTop, _indexPopupLeft, _indexPopupHeight, _indexPopupWidth);
    else
        _indexWindow.document.location.href = doc;

    if (_indexWindow != null && !_indexWindow.closed)
        _indexWindow.focus();
}

function createSummaryPopup(doc)
{
    if (_summaryWindow == null || _summaryWindow.closed)
        _summaryWindow = createPopup(doc, 'summaryPopup', _summaryPopupTop, _summaryPopupLeft, _summaryPopupHeight, _summaryPopupWidth);
    else
        _summaryWindow.document.location.href = doc;

    if (_summaryWindow != null && !_summaryWindow.closed)
        _summaryWindow.focus();
}

function createDetailsPopup(doc)
{
    if (_detailsWindow == null || _detailsWindow.closed)
        _detailsWindow = createPopup(doc, 'detailsPopup', _detailsPopupTop, _detailsPopupLeft, _detailsPopupHeight, _detailsPopupWidth);
    else
        _detailsWindow.document.location.href = doc;

    if (_detailsWindow != null && !_detailsWindow.closed)
        _detailsWindow.focus();
}

// Create a 'popup' window 
function createPopup(doc, name, wtop, wleft, wheight, wwidth, featrs)
{
    var sFeatures = (featrs != null ? featrs : 'titlebar=no, toolbar=no, menubar=no, location=no, status=no');
    sFeatures += ', width=' + wwidth + ', height=' + wheight + ', left=' + wleft + ', top=' + wtop + ', resizable=yes, scrollbars=yes';
    pWindow = window.open(doc, name, sFeatures, true);
    return pWindow;
}

function destroyBrowserPopup()
{
    if (_browserWindow != null && !_browserWindow.closed)
        _browserWindow.close();
    else if (_docBrowser != '' && _floatBrowser)
        destroyPopup('browserPopup');
    _browserWindow = null;
}
function destroyIndexPopup()
{
    if (_indexWindow != null && !_indexWindow.closed)
        _indexWindow.close();
    else if (_docIndex != '' && _floatIndex)
        destroyPopup('indexPopup');
    _indexWindow = null;
}
function destroySummaryPopup()
{
    if (_summaryWindow != null && !_summaryWindow.closed)
        _summaryWindow.close();
    else if (_docSummary != '' && _floatSummary)
        destroyPopup('summaryPopup');
    _summaryWindow = null;
}
function destroyDetailsPopup()
{
    if (_detailsWindow != null && !_detailsWindow.closed)
        _detailsWindow.close();
    else if (_docDetails != '' && _floatDetails)
        destroyPopup('detailsPopup');
    _detailsWindow = null;
}
function destroyDeepLinkPopup()
{
    if (_linkWindow != null && !_linkWindow.closed)
        _linkWindow.close();
    else
        destroyPopup('linkPopup');
    _linkWindow = null;
}
function destroyInfoPopup()
{
    if (_infoWindow != null && !_infoWindow.closed)
        _infoWindow.close();
    else
        destroyPopup('infoPopup');
    _infoWindow = null;
}

// Close the specified popup window when no reference was kept
function destroyPopup(name)
{
    // We do not keep references to popups, so we replace an
    // existing instance with a dummy window and then close it.
    var sFeatures = 'titlebar=no, toolbar=no, menubar=no, location=no, status=no';
    sFeatures += ', width=1, height=1, left=0, top=0, resizable=no, scrollbars=no';
    pWindow = window.open(_blankPage, name, sFeatures, true);
	if (pWindow != null)
        pWindow.close();
}

// Closes all popups currently open. Call this method
// when exiting the main report window
function unloadAllPopups()
{
    destroyBrowserPopup();
    destroyIndexPopup();
    destroySummaryPopup();
    destroyDetailsPopup();
    destroyDeepLinkPopup();
    destroyInfoPopup();
}


/////////////////////////////////////////////////////
// Frames page contruction
/////////////////////////////////////////////////////

function getPageContent()
{
    var sContent = '<html><head></head>\n';
    sContent += '<frameset name="left_right" cols="' + (_browserOnRightSide ? 100 : 0) + '%,*">\n';
    if (_browserOnRightSide)
    {
        sContent += getDiagramSideContent();
        sContent += getBrowserSideContent();
    }
    else
    {
        sContent += getBrowserSideContent();
        sContent += getDiagramSideContent();
    }
    sContent += '</frameset>\n';
    sContent += '</html>\n';
    return sContent;
}

function getBrowserSideContent()
{
    var sContent = '';
    sContent += '<frameset name="browser_index" rows="0%,*">\n';
    sContent += getBrowserContent();
    sContent += getIndexContent();
    sContent += '</frameset>\n';
    return sContent;
}

function getDiagramSideContent()
{
    var sContent = '';
    sContent += '<frameset name="diagram_bottom" rows="100%,*">\n';
    sContent += getDiagramContent();
    sContent += getBottomSideContent();
    sContent += '</frameset>\n';
    return sContent;
}

function getBottomSideContent()
{
    var sContent = '';
    sContent += '<frameset name="summary_details" cols="0%,*">\n';
    sContent += getSummaryContent();
    sContent += getDetailsContent();
    sContent += '</frameset>\n';
    return sContent;
}

function getBrowserContent()
{
    return '<frame src="' + (_docBrowser != '' ? _docBrowser : _blankPage) + '" name="browser" marginwidth="1" marginheight="1">\n';
}
function getIndexContent()
{
    return '<frame src="' + (_docIndex != '' ? _docIndex : _blankPage) + '" name="index" marginwidth="1" marginheight="1">\n';
}
function getDiagramContent()
{
    return '<frame src="' + (_docDiagram != '' ? _docDiagram : _blankPage) + '" name="diagram" marginwidth="1" marginheight="1">\n';
}
function getSummaryContent()
{
    return '<frame src="' + (_docSummary != '' ? _docSummary : _blankPage) + '" name="summary" marginwidth="1" marginheight="1">\n';
}
function getDetailsContent()
{
    return '<frame src="' + (_docDetails != '' ? _docDetails : _blankPage) + '" name="details" marginwidth="1" marginheight="1">\n';
}


/////////////////////////////////////////////////////
// Page layout
/////////////////////////////////////////////////////

function persistBrowserWidth()
{
    if (window.mainframe != null &&
        window.mainframe.left_right != null &&
        !_busyShowingHiding)
    {
        var leftRightCols = window.mainframe.left_right.cols;
        var pos = leftRightCols.indexOf('%', 0)
        if (pos > -1)
            _browserWidth = (_browserOnRightSide ? 100 - leftRightCols.substring(0, pos) : leftRightCols.substring(0, pos));
    }
}
function persistBrowserHeight()
{
    if (window.mainframe != null &&
        window.mainframe.browser_index != null &&
        !_busyShowingHiding)
    {
        var browserIndexRows = window.mainframe.browser_index.rows;
        var pos = browserIndexRows.indexOf('%', 0)
        if (pos > -1)
            _browserHeight = browserIndexRows.substring(0, pos);
    }
}
function persistDiagramHeight()
{
    if (window.mainframe != null &&
        window.mainframe.diagram_bottom != null &&
        !_busyShowingHiding)
    {
        var diagramBottomRows = window.mainframe.diagram_bottom.rows;
        var pos = diagramBottomRows.indexOf('%', 0)
        if (pos > -1)
            _diagramHeight = diagramBottomRows.substring(0, pos);
    }
}
function persistSummaryWidth()
{
    if (window.mainframe != null &&
        window.mainframe.summary_details != null &&
        !_busyShowingHiding)
    {
        var summaryDetailsCols = window.mainframe.summary_details.cols;
        var pos = summaryDetailsCols.indexOf('%', 0)
        if (pos > -1)
            _summaryWidth = summaryDetailsCols.substring(0, pos);
    }
}


/////////////////////////////////////////////////////
// State persistence
/////////////////////////////////////////////////////

// General cookie handling

function getCookie(name)
{
    var allCookies = window.document.cookie.split('; ');
    for (var idx = 0; idx < allCookies.length; idx++)
    {
        var cookieParts = allCookies[idx].split('=');
        if (cookieParts[0] == name)
            return unescape(cookieParts[1]);
    }
    return null;
}

function setCookie(name, value, daysToLive)
{
    if (value && value != '')
    {
        if (daysToLive > 0)
        {
            var now = new Date();
            var end = new Date(now.getTime() + daysToLive * 86400000);
            window.document.cookie = name + '=' + escape(value) + '; expires=' + end.toGMTString();
        }
        else
        {
            window.document.cookie = name + '=' + escape(value);
        }
    }
}

function deleteCookie(name)
{
    // The browser will periodically remove cookies for which
    // the expiration date has elapsed. Here we use that to delete
    // a cookie: we set the expiration date to yesterday.
    var now = new Date();
    var end = new Date(now.getTime() - 86400000);   // One day in the past in ms
    window.document.cookie = name + '=dummy; expires=' + end.toGMTString();
}

function setMessageState(allowMessage)
{
    setCookie('message_state', (allowMessage ? 'true' : 'false'), 0);
}

function getMessageState()
{
    return (getCookie('message_state') != 'false'); // no value: message allowed
}


/////////////////////////////////////////////////////
// Diagram object selection
/////////////////////////////////////////////////////

// Direct the selection box to the specified area on the diagram
function selectDiagramObject(coords)
{
	if (coords == null)
		return;
    var diagramAll = window.mainframe.diagram.document.all;
    if (diagramAll == null)
        return;
    if (diagramAll.select_topleft == null)    // race condition on slow machines
        return;
	if (coords[0] != -1 && coords[1] != -1)
	{
		diagramAll.select_topleft.style.left = '' + coords[0] + 'px';
		diagramAll.select_topleft.style.top = '' + coords[1] + 'px';
		diagramAll.select_topleft.style.display = 'inline';
	}
	if (coords[2] != -1 && coords[3] != -1)
	{
		diagramAll.select_top.style.left = '' + coords[2] + 'px';
		diagramAll.select_top.style.top = '' + coords[3] + 'px';
		diagramAll.select_top.style.display = 'inline';
	}
	if (coords[4] != -1 && coords[5] != -1)
	{
		diagramAll.select_topright.style.left = '' + coords[4] + 'px';
		diagramAll.select_topright.style.top = '' + coords[5] + 'px';
		diagramAll.select_topright.style.display = 'inline';
	}
	if (coords[6] != -1 && coords[7] != -1)
	{
		diagramAll.select_right.style.left = '' + coords[6] + 'px';
		diagramAll.select_right.style.top = '' + coords[7] + 'px';
		diagramAll.select_right.style.display = 'inline';
	}
	if (coords[8] != -1 && coords[9] != -1)
	{
		diagramAll.select_bottomright.style.left = '' + coords[8] + 'px';
		diagramAll.select_bottomright.style.top = '' + coords[9] + 'px';
		diagramAll.select_bottomright.style.display = 'inline';
	}
	if (coords[10] != -1 && coords[11] != -1)
	{
		diagramAll.select_bottom.style.left = '' + coords[10] + 'px';
		diagramAll.select_bottom.style.top = '' + coords[11] + 'px';
		diagramAll.select_bottom.style.display = 'inline';
	}
	if (coords[12] != -1 && coords[13] != -1)
	{
		diagramAll.select_bottomleft.style.left = '' + coords[12] + 'px';
		diagramAll.select_bottomleft.style.top = '' + coords[13] + 'px';
		diagramAll.select_bottomleft.style.display = 'inline';
	}
	if (coords[14] != -1 && coords[15] != -1)
	{
		diagramAll.select_left.style.left = '' + coords[14] + 'px';
		diagramAll.select_left.style.top = '' + coords[15] + 'px';
		diagramAll.select_left.style.display = 'inline';
	}
}

// Remove the selection box from the diagram
function deselectDiagramObjects()
{
    var diagramAll = window.mainframe.diagram.document.all;
    if (diagramAll ==  null)
        return;
    if (diagramAll.select_topleft == null)    // race condition on slow machines
        return;
	diagramAll.select_topleft.style.display = 'none';
	diagramAll.select_top.style.display = 'none';
	diagramAll.select_topright.style.display = 'none';
	diagramAll.select_right.style.display = 'none';
	diagramAll.select_bottomright.style.display = 'none';
	diagramAll.select_bottom.style.display = 'none';
	diagramAll.select_bottomleft.style.display = 'none';
	diagramAll.select_left.style.display = 'none';
	diagramAll.select_topleft.style.left = 0;
	diagramAll.select_topleft.style.top = 0;
	diagramAll.select_top.style.left = 0;
	diagramAll.select_top.style.top = 0;
	diagramAll.select_topright.style.left = 0;
	diagramAll.select_topright.style.top = 0;
	diagramAll.select_right.style.left = 0;
	diagramAll.select_right.style.top = 0;
	diagramAll.select_bottomright.style.left = 0;
	diagramAll.select_bottomright.style.top = 0;
	diagramAll.select_bottom.style.left = 0;
	diagramAll.select_bottom.style.top = 0;
	diagramAll.select_bottomleft.style.left = 0;
	diagramAll.select_bottomleft.style.top = 0;
	diagramAll.select_left.style.left = 0;
	diagramAll.select_left.style.top = 0;
}


/////////////////////////////////////////////////////
// Help screen
/////////////////////////////////////////////////////

function showInfo(infoHref)
{
    _infoWindow = createPopup(infoHref, "infoPopup", 100, 100, 500, 700, 'titlebar=no, toolbar=yes, menubar=no, location=no, status=no');
    if (_infoWindow != null)
        _infoWindow.focus();
}

/////////////////////////////////////////////////////
// End of mainCodeBase.js
/////////////////////////////////////////////////////
